/**
 * Same as Route, but with a hash at the beginning
 */
export declare type Hash = string;
export declare type Params = Record<string, boolean | number | string>;
/**
 * Same as Hash, but without the hash at the beginning
 */
export declare type Route = string;
export declare type Title = string;
export declare type TitleGetter = ((params: Params) => Title) | (() => Title);
export declare type ThunkedString = () => string;
export declare type Token = string;
export declare type ChangeListener = ({ route, params, matchedRoute, }: {
    route: Route;
    params: Params;
    matchedRoute: Route;
}) => void;
export declare type RouterState = {
    params: Params;
    route: Route;
    matchedRoute: Route;
    currentTitle: Title;
    routes: Record<Route, Route>;
    titleGetters: Record<Route, TitleGetter>;
    changeListeners: ChangeListener[];
};
export declare type Router = {
    params: Params;
    route: Route;
    matchedRoute: Route;
    currentTitle: Title;
    setRoutes: (routes: Record<Route, Title | TitleGetter>) => void;
    navigateTo: (route: Route) => void;
    refresh: VoidFunction;
    addChangeListener: (changeListenerToBeAdded: ChangeListener) => void;
    removeChangeListener: (changeListenerToBeRemoved: ChangeListener) => void;
};
